You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

685 lines
17 KiB

9 years ago
9 years ago
9 years ago
9 years ago
9 years ago
9 years ago
9 years ago
9 years ago
9 years ago
9 years ago
9 years ago
9 years ago
9 years ago
  1. #!/bin/bash
  2. ## Bash wrap script to launch the ``compose`` docker with right options.
  3. ##
  4. ##
  5. ## Launcher
  6. ## - should need minimum requirement to run
  7. ## - no shell libs
  8. ##
  9. [[ "${BASH_SOURCE[0]}" != "${0}" ]] && SOURCED=true
  10. ##
  11. ## From kal-shlib
  12. ##
  13. ANSI_ESC=$'\e['
  14. md5_compat() {
  15. if get_path md5sum >/dev/null; then
  16. md5_compat() { md5sum | cut -c -32; }
  17. elif get_path md5 >/dev/null; then
  18. md5_compat() { md5; }
  19. else
  20. die "$exname: required GNU or BSD date not found"
  21. fi
  22. md5_compat
  23. }
  24. ## output on stdout the next record on stdin separated by a '\0'
  25. next-0() {
  26. local ans IFS=''
  27. read -r -d '' ans &&
  28. echo -n "$ans"
  29. }
  30. array_read-0() {
  31. local elt aname
  32. while true; do
  33. for aname in "$@"; do
  34. declare -n cur="$aname"
  35. elt="$(next-0)" || return 0
  36. cur+=("$elt")
  37. done
  38. done
  39. }
  40. str_pattern_matches() {
  41. local str="$1"
  42. shift
  43. for pattern in "$@"; do
  44. eval "[[ \"$str\" == $pattern ]]" && return 0
  45. done
  46. return 1
  47. }
  48. ansi_color() {
  49. local choice="$1"
  50. if [ "$choice" == "tty" ]; then
  51. if [ -t 1 ]; then
  52. choice="yes"
  53. else
  54. choice="no"
  55. fi
  56. fi
  57. if [ "$choice" != "no" ]; then
  58. SET_COL_CHAR="${ANSI_ESC}${COL_CHAR}G"
  59. SET_COL_STATUS="${ANSI_ESC}${COL_STATUS}G"
  60. SET_COL_INFO="${ANSI_ESC}${COL_INFO}G"
  61. SET_COL_ELT="${ANSI_ESC}${COL_ELT}G"
  62. SET_BEGINCOL="${ANSI_ESC}0G"
  63. UP="${ANSI_ESC}1A"
  64. DOWN="${ANSI_ESC}1B"
  65. LEFT="${ANSI_ESC}1D"
  66. RIGHT="${ANSI_ESC}1C"
  67. SAVE="${ANSI_ESC}7"
  68. RESTORE="${ANSI_ESC}8"
  69. NORMAL="${ANSI_ESC}0m"
  70. GRAY="${ANSI_ESC}1;30m"
  71. RED="${ANSI_ESC}1;31m"
  72. GREEN="${ANSI_ESC}1;32m"
  73. YELLOW="${ANSI_ESC}1;33m"
  74. BLUE="${ANSI_ESC}1;34m"
  75. PINK="${ANSI_ESC}1;35m"
  76. CYAN="${ANSI_ESC}1;36m"
  77. WHITE="${ANSI_ESC}1;37m"
  78. DARKGRAY="${ANSI_ESC}0;30m"
  79. DARKRED="${ANSI_ESC}0;31m"
  80. DARKGREEN="${ANSI_ESC}0;32m"
  81. DARKYELLOW="${ANSI_ESC}0;33m"
  82. DARKBLUE="${ANSI_ESC}0;34m"
  83. DARKPINK="${ANSI_ESC}0;35m"
  84. DARKCYAN="${ANSI_ESC}0;36m"
  85. DARKWHITE="${ANSI_ESC}0;37m"
  86. SUCCESS=$GREEN
  87. WARNING=$YELLOW
  88. FAILURE=$RED
  89. NOOP=$BLUE
  90. ON=$SUCCESS
  91. OFF=$FAILURE
  92. ERROR=$FAILURE
  93. else
  94. SET_COL_CHAR=
  95. SET_COL_STATUS=
  96. SET_COL_INFO=
  97. SET_COL_ELT=
  98. SET_BEGINCOL=
  99. NORMAL=
  100. RED=
  101. GREEN=
  102. YELLOW=
  103. BLUE=
  104. GRAY=
  105. WHITE=
  106. DARKGRAY=
  107. DARKRED=
  108. DARKGREEN=
  109. DARKYELLOW=
  110. DARKBLUE=
  111. DARKPINK=
  112. DARKCYAN=
  113. SUCCESS=
  114. WARNING=
  115. FAILURE=
  116. NOOP=
  117. ON=
  118. OFF=
  119. ERROR=
  120. fi
  121. ansi_color="$choice"
  122. export SET_COL_CHAR SET_COL_STATUS SET_COL_INFO SET_COL_ELT \
  123. SET_BEGINCOL UP DOWN LEFT RIGHT SAVE RESTORE NORMAL \
  124. GRAY RED GREEN YELLOW BLUE PINK CYAN WHITE DARKGRAY \
  125. DARKRED DARKGREEN DARKYELLOW DARKBLUE DARKPINK DARKCYAN \
  126. SUCCESS WARNING FAILURE NOOP ON OFF ERROR ansi_color
  127. }
  128. e() { printf "%s" "$*"; }
  129. warn() { e "${YELLOW}Warning:$NORMAL" "$*"$'\n' >&2 ; }
  130. info() { e "${BLUE}II$NORMAL" "$*"$'\n' >&2 ; }
  131. verb() { [ -z "$VERBOSE" ] || e "$*"$'\n' >&2; }
  132. debug() { [ -z "$DEBUG" ] || e "$*"$'\n' >&2; }
  133. err() { e "${RED}Error:$NORMAL $*"$'\n' >&2 ; }
  134. die() { err "$@" ; exit 1; }
  135. ## equivalent of 'xargs echo' with builtins
  136. nspc() {
  137. local content
  138. content=$(printf "%s " $(cat -))
  139. printf "%s" "${content::-1}"
  140. }
  141. get_path() { (
  142. IFS=:
  143. for d in $PATH; do
  144. filename="$d/$1"
  145. [ -f "$filename" -a -x "$filename" ] && {
  146. echo "$d/$1"
  147. return 0
  148. }
  149. done
  150. return 1
  151. ) }
  152. depends() {
  153. ## Avoid colliding with variables that are created with depends.
  154. local __i __path __new_name
  155. for __i in "$@"; do
  156. if ! __path=$(get_path "$__i"); then
  157. __new_name="$(echo "${__i//-/_}")"
  158. if [ "$__new_name" != "$__i" ]; then
  159. depends "$__new_name"
  160. else
  161. err "dependency check: couldn't find '$__i' required command."
  162. exit 1
  163. fi
  164. else
  165. if ! test -z "$__path" ; then
  166. export "$(echo "${__i//- /__}")"="$__path"
  167. fi
  168. fi
  169. done
  170. }
  171. get_os() {
  172. local uname_output
  173. uname_output="$(uname -s)"
  174. case "${uname_output}" in
  175. Linux*) e linux;;
  176. Darwin*) e mac;;
  177. CYGWIN*) e cygwin;;
  178. MINGW*) e mingw;;
  179. *) e "UNKNOWN:${uname_output}";;
  180. esac
  181. }
  182. read-0() {
  183. local eof= IFS=''
  184. while [ "$1" ]; do
  185. read -r -d '' -- "$1" || eof=1
  186. shift
  187. done
  188. [ -z "$eof" ]
  189. }
  190. read-0a() {
  191. local eof= IFS=''
  192. while [ "$1" ]; do
  193. IFS='' read -r -d $'\n' -- "$1" || eof=1
  194. shift
  195. done
  196. [ -z "$eof" ]
  197. }
  198. p0() {
  199. printf "%s\0" "$@"
  200. }
  201. cla.normalize() {
  202. local letters arg i
  203. while [ "$#" != 0 ]; do
  204. arg=$1
  205. case "$arg" in
  206. --)
  207. p0 "$@"
  208. return 0
  209. ;;
  210. --*=*|-*=*)
  211. shift
  212. set -- "${arg%%=*}" "${arg#*=}" "$@"
  213. continue
  214. ;;
  215. --*|-?) :;;
  216. -*)
  217. letters=${arg:1}
  218. shift
  219. i=${#letters}
  220. while ((i--)); do
  221. set -- -${letters:$i:1} "$@"
  222. done
  223. continue
  224. ;;
  225. esac
  226. p0 "$arg"
  227. shift
  228. done
  229. }
  230. docker_has_image() {
  231. local image="$1"
  232. images=$(docker images -q "$image" 2>/dev/null) || {
  233. err "docker images call has failed unexpectedly."
  234. return 1
  235. }
  236. [ -n "$images" ]
  237. }
  238. docker_image_id() {
  239. local image="$1"
  240. image_id=$(docker inspect "$image" --format='{{.Id}}') || return 1
  241. echo "$image_id"
  242. }
  243. ##
  244. ## Compose-core common functions
  245. ##
  246. list_compose_vars() {
  247. while read-0a def; do
  248. def="${def##* }"
  249. def="${def%=*}"
  250. p0 "$def"
  251. done < <(declare -p | grep "^declare -x COMPOSE_[A-Z_]\+=\"")
  252. }
  253. get_running_compose_containers() {
  254. ## XXXvlab: docker bug: there will be a final newline anyway
  255. docker ps --filter label="compose.service" --format='{{.ID}}'
  256. }
  257. get_volumes_for_container() {
  258. local container="$1"
  259. docker inspect \
  260. --format '{{range $mount := .Mounts}}{{$mount.Source}}{{"\x00"}}{{$mount.Destination}}{{"\x00"}}{{end}}' \
  261. "$container"
  262. }
  263. is_volume_used() {
  264. local volume="$1"
  265. while read container_id; do
  266. while read-0 src dst; do
  267. [ "$src" == "$volume" ] && return 0
  268. done < <(get_volumes_for_container "$container_id")
  269. done < <(get_running_compose_containers)
  270. return 1
  271. }
  272. _MULTIOPTION_REGEX='^((-[a-zA-Z]|--[a-zA-Z0-9-]+)(, )?)+'
  273. _MULTIOPTION_REGEX_LINE_FILTER=$_MULTIOPTION_REGEX'(\s|=)'
  274. ##
  275. ## compose launcher functions
  276. ##
  277. clean_unused_sessions() {
  278. for f in "$SESSION_DIR/"*; do
  279. [ -e "$f" ] || continue
  280. is_volume_used "$f" && continue
  281. rm -f "$f"
  282. done
  283. }
  284. relink_subdirs() {
  285. local dir
  286. for dir in "$@"; do
  287. [ -L "$dir" ] || continue
  288. target=$(realpath "$dir")
  289. [ -d "$target" ] || continue
  290. docker_run_opts+=("-v" "$target:$dir")
  291. [ -e "$dir/metadata.yml" ] && continue
  292. relink_subdirs "$dir"/*
  293. done
  294. }
  295. get_tz() {
  296. if [ -n "$TZ" ]; then
  297. :
  298. elif [ -n "$COMPOSE_LOCAL_ROOT" ] && ## previous compose run
  299. [ -e "$COMPOSE_LOCAL_ROOT/etc/timezone" ]; then
  300. read -r TZ < "$COMPOSE_LOCAL_ROOT/etc/timezone"
  301. elif [ -e "/etc/timezone" ]; then ## debian host system timezone
  302. read -r TZ < /etc/timezone
  303. elif [ -e "/etc/localtime" ]; then ## redhat and macosx sys timezone
  304. local fullpath dirname
  305. fullpath="$(readlink -f /etc/localtime)"
  306. dirname="${fullpath%/*}"
  307. TZ=${TZ:-${fullpath##*/}/${dirname##*/}}
  308. else
  309. err "Timezone not found nor inferable !"
  310. echo " compose relies on '/etc/timezone' or '/etc/localtime' to be present " >&2
  311. echo " so as to ensure same timezone for all containers that need it." >&2
  312. echo >&2
  313. echo " You can set a default value for compose by create issuing:" >&2
  314. echo >&2
  315. if [ -n "$COMPOSE_LOCAL_ROOT" ] && [ "$UID" != 0 ]; then
  316. echo " mkdir -p $COMPOSE_LOCAL_ROOT/etc &&" >&2
  317. echo " echo \"Europe/Paris\" > $COMPOSE_LOCAL_ROOT/etc/timezone" >&2
  318. else
  319. echo " echo \"Europe/Paris\" > /etc/timezone" >&2
  320. fi
  321. echo >&2
  322. echo " Of course, you can change 'Europe/Paris' value by any other valid timezone." >&2
  323. echo " timezone." >&2
  324. echo >&2
  325. echo " Notice you can also use \$TZ environment variable, but the value" >&2
  326. echo " will be necessary each time you launch compose." >&2
  327. echo >&2
  328. return 1
  329. fi
  330. e "$TZ"
  331. }
  332. pretty_print() {
  333. while [ "$#" != 0 ]; do
  334. case "$1" in
  335. "-v"|"-e"|"-w")
  336. e "$1" "$2" "\\"$'\n'
  337. shift;;
  338. *)
  339. e "$1 ";;
  340. esac
  341. shift
  342. done
  343. }
  344. mk_docker_run_options() {
  345. ## Order matters, files get to override vars
  346. compose_config_files=(
  347. ## DEFAULT LINUX VARS
  348. /etc/default/charm
  349. /etc/default/datastore
  350. /etc/default/compose
  351. ## COMPOSE SYSTEM-WIDE FILES
  352. /etc/compose.conf
  353. /etc/compose.local.conf
  354. /etc/compose/local.conf
  355. ## COMPOSE USER FILES
  356. ~/.compose/etc/local.conf
  357. ~/.compose.conf
  358. )
  359. docker_run_opts=("-v" "/var/run/docker.sock:/var/run/docker.sock")
  360. ## current dir
  361. if parent=$(while true; do
  362. [ -e "./compose.yml" ] && {
  363. echo "$PWD"
  364. exit 0
  365. }
  366. [ "$PWD" == "/" ] && exit 1
  367. cd ..
  368. done
  369. ); then
  370. docker_path=$COMPOSE_VAR/root/$(basename "$parent")
  371. docker_run_opts+=("-v" "$parent:$docker_path:ro" \
  372. "-w" "$docker_path")
  373. fi
  374. ##
  375. ## Load config files
  376. ##
  377. if [ -z "$DISABLE_SYSTEM_CONFIG_FILE" ]; then
  378. ## XXXvlab: should provide YML config opportunities in possible parent dirs ?
  379. ## userdir ? and global /etc/compose.yml ?
  380. for cfgfile in "${compose_config_files[@]}"; do
  381. [ -e "$cfgfile" ] || continue
  382. docker_run_opts+=("-v" "$cfgfile:$cfgfile:ro")
  383. . "$cfgfile"
  384. done
  385. else
  386. docker_run_opts+=("-e" "DISABLE_SYSTEM_CONFIG_FILE=$DISABLE_SYSTEM_CONFIG_FILE")
  387. fi
  388. COMPOSE_LOCAL_ROOT=${COMPOSE_LOCAL_ROOT:-"$HOME/.compose"}
  389. case "$(get_os)" in
  390. linux)
  391. COMPOSE_VAR=${COMPOSE_VAR:-/var/lib/compose}
  392. COMPOSE_CACHE=${COMPOSE_CACHE:-/var/cache/compose}
  393. DATASTORE=${DATASTORE:-/srv/datastore/data}
  394. CONFIGSTORE=${CONFIGSTORE:-/srv/datastore/config}
  395. if [ "$UID" == 0 ]; then
  396. SESSION_DIR=${SESSION_DIR:-"$COMPOSE_VAR"/sessions}
  397. CHARM_STORE=${CHARM_STORE:-/srv/charm-store}
  398. TZ_PATH=${TZ_PATH:-"$COMPOSE_VAR"/timezones}
  399. else
  400. SESSION_DIR=${SESSION_DIR:-"$COMPOSE_LOCAL_ROOT"/sessions}
  401. CHARM_STORE=${CHARM_STORE:-"$HOME"/.charm-store}
  402. TZ_PATH=${TZ_PATH:-"$COMPOSE_LOCAL_ROOT"/timezones}
  403. fi
  404. ;;
  405. mac)
  406. COMPOSE_VAR=${COMPOSE_VAR:-"$COMPOSE_LOCAL_ROOT"/lib}
  407. COMPOSE_CACHE=${COMPOSE_CACHE:-"$COMPOSE_LOCAL_ROOT"/cache}
  408. SESSION_DIR=${SESSION_DIR:-"$COMPOSE_LOCAL_ROOT"/sessions}
  409. DATASTORE=${DATASTORE:-"$COMPOSE_LOCAL_ROOT"/data}
  410. CONFIGSTORE=${CONFIGSTORE:-"$COMPOSE_LOCAL_ROOT"/config}
  411. CHARM_STORE=${CHARM_STORE:-"$HOME"/.charm-store}
  412. TZ_PATH=${TZ_PATH:-"$COMPOSE_LOCAL_ROOT"/timezones}
  413. ;;
  414. *)
  415. echo "System '$os' not supported yet." >&2
  416. exit 1
  417. ;;
  418. esac
  419. ## get TZ value and prepare TZ_PATH
  420. TZ=$(get_tz) || exit 1
  421. mkdir -p "${TZ_PATH}"
  422. TZ_PATH="${TZ_PATH}/$(e "$TZ" | sha256sum | cut -c 1-8)" || exit 1
  423. [ -e "$TZ_PATH" ] || e "$TZ" > "$TZ_PATH"
  424. ## CACHE/DATA DIRS
  425. docker_run_opts+=("-v" "$COMPOSE_VAR:/var/lib/compose")
  426. docker_run_opts+=("-v" "$COMPOSE_CACHE:/var/cache/compose")
  427. docker_run_opts+=("-v" "$TZ_PATH:/etc/timezone:ro")
  428. ##
  429. ## Checking vars
  430. ##
  431. ## CHARM_STORE
  432. [ -e "$CHARM_STORE" ] || mkdir -p "$CHARM_STORE" || exit 1
  433. [ -L "$CHARM_STORE" ] && {
  434. CHARM_STORE=$(readlink -f "$CHARM_STORE") || exit 1
  435. }
  436. docker_run_opts+=(
  437. "-v" "$CHARM_STORE:/srv/charm-store:ro"
  438. "-e" "CHARM_STORE=/srv/charm-store"
  439. "-e" "HOST_CHARM_STORE=$CHARM_STORE"
  440. )
  441. relink_subdirs "$CHARM_STORE"/*
  442. ## DEFAULT_COMPOSE_FILE
  443. if [ "${DEFAULT_COMPOSE_FILE+x}" ]; then
  444. DEFAULT_COMPOSE_FILE=$(realpath "$DEFAULT_COMPOSE_FILE")
  445. dirname=$(dirname "$DEFAULT_COMPOSE_FILE")/
  446. if [ -e "${DEFAULT_COMPOSE_FILE}" ]; then
  447. docker_run_opts+=("-v" "$dirname:$dirname:ro")
  448. fi
  449. fi
  450. ## COMPOSE_YML_FILE
  451. if [ "${COMPOSE_YML_FILE+x}" ]; then
  452. if [ -e "${COMPOSE_YML_FILE}" ]; then
  453. docker_run_opts+=(
  454. "-v" "$COMPOSE_YML_FILE:/tmp/compose.yml:ro"
  455. "-e" "COMPOSE_YML_FILE=/tmp/compose.yml"
  456. "-e" "HOST_COMPOSE_YML_FILE=/tmp/compose.yml"
  457. )
  458. fi
  459. fi
  460. ## DATASTORE and CONFIGSTORE
  461. docker_run_opts+=(
  462. "-v" "$DATASTORE:/srv/datastore/data:rw"
  463. "-e" "DATASTORE=/srv/datastore/data"
  464. "-e" "HOST_DATASTORE=$DATASTORE"
  465. "-v" "$CONFIGSTORE:/srv/datastore/config:rw"
  466. "-e" "CONFIGSTORE=/srv/datastore/config"
  467. "-e" "HOST_CONFIGSTORE=$CONFIGSTORE"
  468. )
  469. docker_run_opts+=("-v" "$HOME/.docker:/root/.docker")
  470. COMPOSE_DOCKER_IMAGE=${COMPOSE_DOCKER_IMAGE:-docker.0k.io/compose}
  471. docker_run_opts+=("-e" "COMPOSE_DOCKER_IMAGE=$COMPOSE_DOCKER_IMAGE")
  472. ## SSH config
  473. docker_run_opts+=(
  474. "-v" "$HOME/.ssh:/root/.ssh:ro"
  475. "-v" "/etc/ssh:/etc/ssh:ro"
  476. )
  477. COMPOSE_LAUNCHER_BIN=$(readlink -f "${BASH_SOURCE[0]}")
  478. docker_run_opts+=("-v" "$COMPOSE_LAUNCHER_BIN:/usr/local/bin/compose")
  479. while read-0 var; do
  480. case "$var" in
  481. COMPOSE_YML_FILE|COMPOSE_LAUNCHER_BIN|COMPOSE_DOCKER_IMAGE|\
  482. COMPOSE_LAUNCHER_OPTS|COMPOSE_VAR|COMPOSE_CACHE)
  483. :
  484. ;;
  485. *)
  486. docker_run_opts+=("-e" "$var=${!var}")
  487. ;;
  488. esac
  489. done < <(list_compose_vars)
  490. filename=$(mktemp -p /tmp/ -t launch_opts-XXXXXXXXXXXXXXXX)
  491. {
  492. p0 "${docker_run_opts[@]}"
  493. } > "$filename"
  494. sha=$(sha256sum "$filename")
  495. sha=${sha:0:64}
  496. src="$SESSION_DIR/$UID-$sha"
  497. dest="/var/lib/compose/sessions/$UID-$sha"
  498. {
  499. p0 "-v" "$SESSION_DIR/$UID-$sha:$dest:ro"
  500. p0 "-e" "COMPOSE_LAUNCHER_OPTS=$dest"
  501. p0 "-e" "COMPOSE_LAUNCHER_BIN=$COMPOSE_LAUNCHER_BIN"
  502. } >> "$filename"
  503. mkdir -p "$SESSION_DIR" || return 1
  504. mv -f "$filename" "$SESSION_DIR/$UID-$sha" || return 1
  505. echo "$SESSION_DIR/$UID-$sha"
  506. if [ -n "$DEBUG" ]; then
  507. echo "${WHITE}Environment:${NORMAL}"
  508. echo " COMPOSE_DOCKER_IMAGE: $COMPOSE_DOCKER_IMAGE"
  509. echo " CHARM_STORE: $CHARM_STORE"
  510. echo " DATASTORE: $DATASTORE"
  511. echo " CONFIGSTORE: $CONFIGSTORE"
  512. echo " COMPOSE_VAR: $COMPOSE_VAR"
  513. echo " COMPOSE_CACHE: $COMPOSE_CACHE"
  514. echo " SESSION_DIR: $SESSION_DIR"
  515. echo " TZ_PATH: $TZ_PATH"
  516. fi >&2
  517. }
  518. run() {
  519. local os docker_run_opts
  520. docker_run_opts=()
  521. if [ -z "$COMPOSE_LAUNCHER_OPTS" ]; then
  522. clean_unused_sessions
  523. COMPOSE_LAUNCHER_OPTS="$(mk_docker_run_options)"
  524. fi
  525. while read-0 opt; do
  526. docker_run_opts+=("$opt")
  527. ## catch COMPOSE_DOCKER_IMAGE
  528. if [[ "$env" == "true" && "$opt" == "COMPOSE_DOCKER_IMAGE="* ]]; then
  529. COMPOSE_DOCKER_IMAGE=${opt##COMPOSE_DOCKER_IMAGE=}
  530. elif [ "$opt" == "-e" ]; then
  531. env=true
  532. else
  533. env=
  534. fi
  535. done < <(cat "$COMPOSE_LAUNCHER_OPTS")
  536. [ -t 0 ] && docker_run_opts+=("-i")
  537. [ -t 1 ] && docker_run_opts+=("-t")
  538. if [ -n "$DEBUG" ] || [ -n "$DRY_RUN" ]; then
  539. debug "${WHITE}Launching:${NORMAL}"
  540. echo "docker run --rm \\"
  541. pretty_print "${docker_run_opts[@]}" | sed -r 's/^/ /g;s/([^\])$/\1\\\n/g'
  542. echo " ${COMPOSE_DOCKER_IMAGE} \\"
  543. echo " " "$@"
  544. fi | { if [ -n "$DEBUG" ]; then sed -r 's/^/ /g'; else cat; fi } >&2
  545. if [ -z "$DRY_RUN" ]; then
  546. debug "${WHITE}Execution:${NORMAL}"
  547. exec docker run --rm "${docker_run_opts[@]}" "${COMPOSE_DOCKER_IMAGE}" "$@"
  548. fi
  549. }
  550. [ "$SOURCED" ] && return 0
  551. ##
  552. ## Code
  553. ##
  554. depends docker cat readlink sed realpath
  555. ansi_color "${ansi_color:-tty}"
  556. run "$@"